Package: scDotPlot
Title: Cluster a Single-cell RNA-seq Dot Plot
Version: 1.3.1
Authors@R: c(
    person(given = c("Benjamin", "I"),
           family = "Laufer",
           role = c("aut", "cre"),
           email = "blaufer@gmail.com"),
    person(given = c("Brad", "A"),
           family = "Friedman",
           role = c("aut")))
Description: Dot plots of single-cell RNA-seq data allow for an examination of the relationships between cell groupings (e.g. clusters) and marker gene expression. The scDotPlot package offers a unified approach to perform a hierarchical clustering analysis and add annotations to the columns and/or rows of a scRNA-seq dot plot. It works with SingleCellExperiment and Seurat objects as well as data frames.
License: Artistic-2.0
URL: https://github.com/ben-laufer/scDotPlot
BugReports: https://github.com/ben-laufer/scDotPlot/issues
biocViews: Software, Visualization, DifferentialExpression,
        GeneExpression, Transcription, RNASeq, SingleCell, Sequencing,
        Clustering
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Depends: R (>= 4.4.0)
Imports: aplot, BiocGenerics, cli, dplyr, ggplot2, ggsci, ggtree,
        grDevices, magrittr, purrr, rlang, scales, scater, Seurat,
        SingleCellExperiment, stats, stringr, tibble, tidyr
Suggests: AnnotationDbi, BiocStyle, knitr, rmarkdown, scran, scRNAseq,
        scuttle, SeuratObject, testthat, vdiffr
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/scDotPlot
git_branch: devel
git_last_commit: 4db1f01
git_last_commit_date: 2025-07-10
Repository: Bioconductor 3.22
Date/Publication: 2025-10-07
NeedsCompilation: no
Packaged: 2025-10-07 23:56:39 UTC; biocbuild
Author: Benjamin I Laufer [aut, cre],
  Brad A Friedman [aut]
Maintainer: Benjamin I Laufer <blaufer@gmail.com>

# scDotPlot

<!-- badges: start -->

<!-- badges: end -->

 Dot plots of single-cell RNA-seq data allow for an examination of the relationships between cell groupings (e.g. clusters) and marker gene expression. The scDotPlot package offers a unified approach to perform a hierarchical clustering analysis and add multiple annotations to the columns and/or rows of a scRNA-seq dot plot. It works with SingleCellExperiment and Seurat objects as well as data frames.

## Installation

scDotPlot can be installed from [Bioconductor](https://bioconductor.org/packages/scDotPlot):

``` r
if (!requireNamespace("BiocManager", quietly = TRUE)){
      install.packages("BiocManager")
  }

BiocManager::install("scDotPlot")
```

To install the development version directly from GitHub:

```r
if(!requireNamespace("remotes", quietly = TRUE)){
    install.packages("remotes")
  }

remotes::install_github("ben-laufer/scDotPlot")
```

## Examples

See the package [vignette](https://bioconductor.org/packages/release/bioc/vignettes/gg4way/inst/doc/scDotPlot.html).

## ----Setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(collapse = TRUE,
                      message = FALSE,
                      warning = FALSE,
                      crop = NULL)

## ----Install, eval = FALSE----------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE)) {
#     install.packages("BiocManager")
# }
# 
# BiocManager::install("scDotPlot")

## ----Install GitHub, eval = FALSE---------------------------------------------
# if (!requireNamespace("remotes", quietly = TRUE)) {
#     install.packages("remotes")
# }
# 
# remotes::install_github("ben-laufer/scDotPlot")

## ----Prepare SingleCellExperiment---------------------------------------------
library(scRNAseq)
library(scuttle)

sce <- ZeiselBrainData()

sce <- sce |> 
    logNormCounts() |>  
    subset(x = _, , level2class != "(none)")

## ----Get features SingleCellExperiment----------------------------------------
library(scran)
library(purrr)
library(dplyr)
library(AnnotationDbi)

features <- sce |>
    scoreMarkers(sce$level1class) |>
    map(~ .x |>
            as.data.frame() |>
            arrange(desc(mean.AUC))|>
            dplyr::slice(1:6) |>
            rownames()) |> 
    unlist2()

rowData(sce)$Marker <- features[match(rownames(sce), features)] |>
    names()

## ----scePlot1, fig.cap = "scDotPlot of SingleCellExperiment logcounts", fig.width=12, fig.height=12, dpi=50----
library(scDotPlot)
library(ggsci)

sce |>
    scDotPlot(features = features,
              group = "level2class",
              groupAnno = "level1class",
              featureAnno = "Marker",
              groupLegends = FALSE,
              annoColors = list("level1class" = pal_d3()(7),
                                "Marker" = pal_d3()(7)),
              annoWidth = 0.02)

## ----scePlot2, fig.cap = "scDotPlot of SingleCellExperiment Z-scores", fig.width=12, fig.height=12, dpi=50----
sce |>
    scDotPlot(scale = TRUE,
              features = features,
              group = "level2class",
              groupAnno = "level1class",
              featureAnno = "Marker",
              groupLegends = FALSE,
              annoColors = list("level1class" = pal_d3()(7),
                                "Marker" = pal_d3()(7)),
              annoWidth = 0.02)

## ----Get features Seurat------------------------------------------------------
library(Seurat)
library(SeuratObject)
library(tibble)

data("pbmc_small")

features <- pbmc_small |>
    FindAllMarkers(only.pos = TRUE, verbose = FALSE) |>
    group_by(cluster) |>
    dplyr::slice(1:6) |>
    dplyr::select(cluster, gene)

pbmc_small[[DefaultAssay(pbmc_small)]][[]] <- pbmc_small[[DefaultAssay(pbmc_small)]][[]] |>
    rownames_to_column("gene") |> 
    left_join(features, by = "gene") |> 
    column_to_rownames("gene")

features <- features |> 
    deframe()

## ----SeuratPlot1, fig.cap = "scDotPlot of Seurat logcounts", fig.width=4, fig.height=5, out.width="75%", out.height="75%", dpi=50----
pbmc_small |>
    scDotPlot(features = features,
              group = "RNA_snn_res.1",
              groupAnno = "RNA_snn_res.1",
              featureAnno = "cluster",
              annoColors = list("RNA_snn_res.1" = pal_d3()(7),
                                "cluster" = pal_d3()(7)),
              groupLegends = FALSE,
              annoWidth = 0.075)

## ----SeuratPlot2, fig.cap = "scDotPlot of Seurat Z-scores", fig.width=4, fig.height=5, out.width="75%", out.height="75%", dpi=50----
pbmc_small |>
    scDotPlot(scale = TRUE,
              features = features,
              group = "RNA_snn_res.1",
              groupAnno = "RNA_snn_res.1",
              featureAnno = "cluster",
              annoColors = list("RNA_snn_res.1" = pal_d3()(7),
                                "cluster" = pal_d3()(7)),
              groupLegends = FALSE,
              annoWidth = 0.075)

## ----Session info, echo=FALSE-------------------------------------------------
sessionInfo()

#' @title scDotPlot
#' @description Create dot plot of gene expression profiles that can be
#'  annotated with hierarchical clustering from \link[ggtree]{ggtree} using
#'  \link[aplot:plot-insertion]{aplot}
#' @param object An object with normalized data
#' \itemize{
#'  \item \link[SingleCellExperiment:SingleCellExperiment-class]{SingleCellExperiment}
#'  \item \link[SeuratObject:Seurat-class]{Seurat}
#'  \item A data.frame with the following columns: "NumDetected", "Feature", "Group", "Average"
#' }
#' @param features Character vector with genes of interest
#' @param group Column name from colData/metadata of the object to group cells by
#' @param block Column name from colData of a SingleCellExperiment object
#'  to use as a blocking factor (e.g. batch or sample)
#' @param swap_rownames Column name from rowData of a SingleCellExperiment
#'  object to match to features
#' @param scale Logical indicating whether the data should be scaled and centered
#' @param AverageThreshold Numeric specifying threshold for average expression,
#'  where values below AverageThreshold and NumDetectedThreshold are transparent
#' @param NumDetectedThreshold Numeric specifying threshold for fraction of cells,
#'  where values below AverageThreshold and NumDetectedThreshold are transparent
#' @param cluster Logical specifying whether to perform hierarchical clustering
#'  analysis on both the rows and columns
#' @param clusterRows Logical specifying whether to perform hierarchical clustering
#'  analysis on the rows
#' @param clusterColumns Logical specifying whether to perform hierarchical clustering
#'  analysis on the columns
#' @param groupAnno Cell annotations that are stored as names of columns
#'  in colData of sce with annotations
#' @param featureAnno Feature annotations that are stored as names of rows
#'  in rowData of sce with annotations
#' @param treeWidth Numeric specifying width of the row tree relative to
#'  the dotPlot
#' @param treeHeight Numeric specifying height of the column tree relative to
#'  the dotPlot
#' @param annoWidth Numeric specifying the width of the row annotation relative
#'  to the dotPlot
#' @param annoHeight Numeric specifying height of the column annotation relative
#'  to the dotPlot
#' @param annoColors A list with a name for each annotation that contains
#'  a named vector of colors, where the name is the pairing of values to colors
#' @param dotColors A character vector specifying the colors to be used
#'  in the gradient for the dots. If scale is set to TRUE, the first 3 colors
#'  will be used for the negative, zero, and positive values, respectively.
#' @param groupLegends Logical indicating whether to show legends for group
#'  annotations
#' @param featureLegends Logical indicating whether to show legends for feature
#'  annotations
#' @param fontSize Numeric specifying the base font size in pts
#' @param fontFamily Character specifying the base font family
#' @param flipPlot Logical indicating whether to flip the x and y coordinates
#' @param ... Additional unused arguments
#' @details The data for the dot plot is generated from different sources
#'  depending on the object:
#' \itemize{
#'  \item \code{SingleCellExperiment:} \link[scater]{plotDots}
#'  \item \code{Seurat:} \link[Seurat]{DotPlot}
#' }
#' @return
#'  \itemize{
#'      \item When \code{cluster = TRUE}, a \code{aplot} object
#'      \item When \code{cluster = FALSE}, a \code{ggplot2} object
#' }
#' @references \url{https://yulab-smu.top/pkgdocs/aplot.html#a-single-cell-example}
#' @export
#'
scDotPlot <- function(object,
                      ...){
    UseMethod("scDotPlot")
}

#' @rdname scDotPlot
#' @name scDotPlot
#' @order 1
#' @importFrom SingleCellExperiment rowData colData
#' @importFrom rlang syms sym
#' @importFrom purrr set_names
#' @importFrom scater plotDots
#' @importFrom tibble as_tibble
#' @importFrom BiocGenerics as.data.frame
#' @importFrom dplyr pull rename mutate left_join select distinct
#' @importFrom stringr str_sort
#' @import ggplot2
#' @importFrom cli cli_abort
#' @importFrom utils packageVersion
#' @importFrom magrittr %>%
#' @examples
#' data("pbmc_small", package = "SeuratObject")
#' pbmc_small |>
#'     scDotPlot(features = Seurat::VariableFeatures(pbmc_small),
#'               group = "RNA_snn_res.1")
#' @export
#'
scDotPlot.SingleCellExperiment <- function(object,
                                           features = features,
                                           group = NULL,
                                           block = NULL,
                                           swap_rownames = NULL,
                                           scale = FALSE,
                                           cluster = TRUE,
                                           clusterRows = cluster,
                                           clusterColumns = cluster,
                                           AverageThreshold = ifelse(scale == FALSE, 0, -Inf),
                                           NumDetectedThreshold = 0.01,
                                           groupAnno = FALSE,
                                           featureAnno = FALSE,
                                           treeWidth = 0.1,
                                           treeHeight = 0.1,
                                           annoWidth = 0.05,
                                           annoHeight = 0.02,
                                           annoColors = NULL,
                                           dotColors = NULL,
                                           groupLegends = TRUE,
                                           featureLegends = TRUE,
                                           fontSize = 11,
                                           fontFamily = "",
                                           flipPlot = FALSE,
                                           ...){

    featureCheck <- if(is.null(swap_rownames)){
        rownames(object)
    }else if(swap_rownames %in% colnames(SingleCellExperiment::rowData(object))){
        SingleCellExperiment::rowData(object)[ ,swap_rownames]
    }

    if(!all(features %in% featureCheck)){
        missingFeatures <- features[!features %in% featureCheck]
        cli::cli_abort(c("The following features are not in the rowData of the object:",
                         missingFeatures %>%
                             purrr::set_names(rep("x", length(missingFeatures)))))
    }

    {object %>%
            scater::plotDots(features = features,
                             group = group,
                             block = block,
                             swap_rownames = swap_rownames,
                             scale = scale,
                             center = scale)}$data %>%
        tibble::as_tibble() %>%
        {if(!isFALSE(groupAnno)){
            dplyr::left_join(.,
                             object %>%
                                 SingleCellExperiment::colData() %>%
                                 BiocGenerics::as.data.frame() %>%
                                 dplyr::select(!!!rlang::syms(groupAnno),
                                               Group = !!rlang::sym(group)) %>%
                                 dplyr::distinct(),
                             by = "Group")
        }else{
            .
        }} %>%
        {if(group %in% groupAnno){
            dplyr::mutate(., !!group := Group)
        }else{
            .
        }} %>%
        {if(!isFALSE(featureAnno)){
            dplyr::left_join(.,
                             object %>%
                                 SingleCellExperiment::rowData() %>%
                                 BiocGenerics::as.data.frame() %>%
                                 tibble::rownames_to_column("rownames") %>%
                                 dplyr::select(!!!rlang::syms(featureAnno),
                                               Feature = !!rlang::sym(ifelse(!is.null(swap_rownames),
                                                                             swap_rownames,
                                                                             "rownames"))) %>%
                                 dplyr::distinct(),
                             by = "Feature")
        }else{
            .
        }} %>%
        scDotPlot.default(group = NULL,
                          features = features,
                          scale = scale,
                          cluster = cluster,
                          clusterRows = clusterRows,
                          clusterColumns = clusterColumns,
                          AverageThreshold = AverageThreshold,
                          NumDetectedThreshold = NumDetectedThreshold,
                          groupAnno = groupAnno,
                          featureAnno = featureAnno,
                          treeWidth = treeWidth,
                          treeHeight = treeHeight,
                          annoWidth = annoWidth,
                          annoHeight = annoHeight,
                          annoColors = annoColors,
                          dotColors = dotColors,
                          groupLegends = groupLegends,
                          featureLegends = featureLegends,
                          fontSize = fontSize,
                          fontFamily = fontFamily,
                          flipPlot = flipPlot,
                          ...)
}

#' @rdname scDotPlot
#' @name scDotPlot
#' @order 2
#' @importFrom Seurat DotPlot FetchData DefaultAssay
#' @importFrom tibble as_tibble rownames_to_column
#' @importFrom dplyr rename mutate left_join select distinct
#' @importFrom rlang sym syms
#' @importFrom cli cli_abort
#' @importFrom utils packageVersion
#' @importFrom stats setNames
#' @importFrom magrittr %>%
#' @export
#'
scDotPlot.Seurat <- function(object,
                             features = features,
                             group = NULL,
                             block = NULL,
                             swap_rownames = NULL,
                             scale = FALSE,
                             cluster = TRUE,
                             clusterRows = cluster,
                             clusterColumns = cluster,
                             AverageThreshold = ifelse(scale == FALSE, 0, -Inf),
                             NumDetectedThreshold = 0.01,
                             groupAnno = FALSE,
                             featureAnno = FALSE,
                             treeWidth = 0.1,
                             treeHeight = 0.1,
                             annoWidth = 0.05,
                             annoHeight = 0.02,
                             annoColors = NULL,
                             dotColors = NULL,
                             groupLegends = TRUE,
                             featureLegends = TRUE,
                             fontSize = 11,
                             fontFamily = "",
                             flipPlot = FALSE,
                             ...){
    if(!is.null(block) | !is.null(swap_rownames)){
        cli::cli_abort("The {.field block} and {.field swap_rownames} \
               arguments are not supported for Seurat objects.\
               See {.fn Seurat::as.SingleCellExperiment} \
               for information about how to convert the object.")
    }

    {object %>%
            Seurat::DotPlot(object = .,
                            features = stats::setNames(features, NULL),
                            group.by = group,
                            scale = scale)}$data %>%
        tibble::as_tibble() %>%
        dplyr::rename(Average = avg.exp.scaled,
                      NumDetected = pct.exp,
                      Feature = features.plot,
                      Group = id) %>%
        dplyr::mutate(NumDetected = NumDetected/100) %>%
        {if(!isFALSE(groupAnno)){
            dplyr::left_join(.,
                             object %>%
                                 Seurat::FetchData(c(groupAnno, group)) %>%
                                 tibble::as_tibble() %>%
                                 dplyr::rename("Group" = !!rlang::sym(group)) %>%
                                 dplyr::distinct(),
                             by = "Group",
                             relationship = "many-to-many")
        }else{
            .
        }} %>%
        {if(group %in% groupAnno){
            dplyr::mutate(., !!group := Group)
        }else{
            .
        }} %>%
        {if(!isFALSE(featureAnno)){
            dplyr::left_join(.,
                             object[[Seurat::DefaultAssay(object)]][[]] %>%
                                 tibble::rownames_to_column("rownames") %>%
                                 dplyr::select(!!!rlang::syms(featureAnno),
                                               Feature = "rownames") %>%
                                 dplyr::distinct(),
                             by = "Feature")
        }else{
            .
        }} %>%
        scDotPlot.default(group = NULL,
                          features = features,
                          scale = scale,
                          cluster = cluster,
                          clusterRows = clusterRows,
                          clusterColumns = clusterColumns,
                          AverageThreshold = AverageThreshold,
                          NumDetectedThreshold = NumDetectedThreshold,
                          groupAnno = groupAnno,
                          featureAnno = featureAnno,
                          treeWidth = treeWidth,
                          treeHeight = treeHeight,
                          annoWidth = annoWidth,
                          annoHeight = annoHeight,
                          annoColors = annoColors,
                          dotColors = dotColors,
                          groupLegends = groupLegends,
                          featureLegends = featureLegends,
                          fontSize = fontSize,
                          fontFamily = fontFamily,
                          flipPlot = flipPlot,
                          ...)
}

#' @rdname scDotPlot
#' @name scDotPlot
#' @order 3
#' @export
#'
scDotPlot.default <- function(object,
                              features = NULL,
                              group = NULL,
                              block = NULL,
                              swap_rownames = NULL,
                              scale = FALSE,
                              cluster = TRUE,
                              clusterRows = cluster,
                              clusterColumns = cluster,
                              AverageThreshold = ifelse(scale == FALSE, 0, -Inf),
                              NumDetectedThreshold = 0.01,
                              groupAnno = FALSE,
                              featureAnno = FALSE,
                              treeWidth = 0.1,
                              treeHeight = 0.1,
                              annoWidth = 0.05,
                              annoHeight = 0.02,
                              annoColors = NULL,
                              dotColors = NULL,
                              groupLegends = TRUE,
                              featureLegends = TRUE,
                              fontSize = 11,
                              fontFamily = "",
                              flipPlot = FALSE,
                              ...){
    dotPlot <- object %>%
        {if(!is.null(features)){
            dplyr::mutate(., Feature = factor(Feature, levels = features))
        }else{
            .
        }} %>%
        .baseDotPlot(group = group,
                     scale = scale,
                     AverageThreshold = AverageThreshold,
                     NumDetectedThreshold = NumDetectedThreshold,
                     dotColors = dotColors,
                     fontSize = fontSize,
                     fontFamily = fontFamily,
                     flipPlot = flipPlot)

    if(any(cluster == TRUE, !is.null(groupAnno), !is.null(featureAnno))){
        dotPlot %>%
            .annotateDotPlot(clusterRows = clusterRows,
                             clusterColumns = clusterColumns,
                             groupAnno = groupAnno,
                             featureAnno = featureAnno,
                             treeWidth = treeWidth,
                             treeHeight = treeHeight,
                             annoWidth = annoWidth,
                             annoHeight = annoHeight,
                             annoColors = annoColors,
                             groupLegends = groupLegends,
                             featureLegends = featureLegends,
                             fontSize = fontSize,
                             fontFamily = fontFamily,
                             flipPlot = flipPlot)
    }else{
        dotPlot
    }
}

test_that("base plot works", {
    data("pbmc_small", package = "SeuratObject")
    pbmc_small %>%
        scDotPlot(cluster = FALSE,
                  features = VariableFeatures(.),
                  group = "RNA_snn_res.1") %T>%
        {expect_true(is_ggplot(.))} %>%
        expect_doppelganger("base plot", .)
})

test_that("plot annotation works", {
    data("pbmc_small", package = "SeuratObject")
    pbmc_small %>%
        scDotPlot(features = VariableFeatures(.),
                  group = "RNA_snn_res.1") %T>%
        suppressWarnings() %T>% # https://github.com/YuLab-SMU/ggtree/issues/656
        expect_s3_class("aplot") %>%
        expect_doppelganger("plot annotation", .)
})

#' @title Cluster Dot Plot
#' @inheritParams scDotPlot
#' @importFrom tibble as_tibble column_to_rownames
#' @importFrom dplyr select
#' @importFrom tidyr pivot_wider
#' @importFrom stats dist hclust
#' @importFrom rlang sym
#' @importFrom purrr set_names map reduce
#' @importFrom ggplot2 scale_y_discrete
#' @importFrom ggtree ggtree layout_dendrogram
#' @importFrom aplot insert_top insert_left
#' @importFrom magrittr %>%
#' @return A aplot
#' @keywords internal
#'
.annotateDotPlot <- function(dotPlot,
                             clusterRows = TRUE,
                             clusterColumns = TRUE,
                             groupAnno = FALSE,
                             featureAnno = FALSE,
                             treeWidth = 0.1,
                             treeHeight = 0.1,
                             annoWidth = 0.05,
                             annoHeight = 0.02,
                             annoColors = NULL,
                             groupLegends = TRUE,
                             featureLegends = TRUE,
                             fontSize = 11,
                             fontFamily = "",
                             flipPlot = FALSE){

    plotMatrix <- dotPlot$data %>%
        tibble::as_tibble() %>%
        dplyr::select(Feature, Group, Average) %>%
        tidyr::pivot_wider(names_from = Group, values_from = Average) %>%
        tibble::column_to_rownames("Feature") %>%
        as.matrix()

    if(!all(groupAnno == FALSE)){
        colLabels <- groupAnno %>%
            purrr::set_names() %>%
            purrr::map(.createAnno,
                       annoType = "column",
                       dotPlot = dotPlot,
                       annoColors = annoColors,
                       groupLegends = groupLegends,
                       fontSize = fontSize,
                       fontFamily = fontFamily,
                       flipPlot = flipPlot)
    }else{
        colLabels <- NULL
    }

    if(!all(featureAnno == FALSE)){
        rowLabels <- featureAnno %>%
            purrr::set_names() %>%
            purrr::map(.createAnno,
                       annoType = "row",
                       dotPlot = dotPlot,
                       annoColors = annoColors,
                       featureLegends = featureLegends,
                       fontSize = fontSize,
                       fontFamily = fontFamily,
                       flipPlot = flipPlot)
    }else{
        rowLabels <- NULL
    }

    if(clusterRows == TRUE){
        treeRow <- plotMatrix %>%
            {if(flipPlot == FALSE){
                .
            }else if(flipPlot == TRUE){
                t(.)
            }} %>%
            stats::dist() %>%
            stats::hclust() %>%
            ggtree::ggtree(branch.length = "none")
    }

    if(clusterColumns == TRUE){
        treeCol <- plotMatrix %>%
            {if(flipPlot == FALSE){
                t(.)
            }else if(flipPlot == TRUE){
                .
            }} %>%
            stats::dist() %>%
            stats::hclust() %>%
            ggtree::ggtree(branch.length = "none") +
            ggtree::layout_dendrogram()
    }

    (dotPlot +
            ggplot2::scale_y_discrete(position = "right")) %>%
        purrr::reduce(if(flipPlot == FALSE){colLabels}else{rowLabels},
                      ~ aplot::insert_top(.x, .y, height = annoHeight),
                      .init = .) %>%
        purrr::reduce(if(flipPlot == FALSE){rowLabels}else{colLabels},
                      ~ aplot::insert_left(.x, .y, width = annoWidth),
                      .init = .) %>%
        {if(clusterRows == TRUE){
            aplot::insert_left(., treeRow, width = treeWidth)
        }else{
            .
        }} %>%
        {if(clusterColumns == TRUE){
            aplot::insert_top(., treeCol, height = treeHeight)
        }else{
            .
        }}
}

#' @title Dot Plot Base
#' @inheritParams scDotPlot
#' @importFrom dplyr mutate case_when
#' @importFrom rlang sym
#' @importFrom scales muted
#' @importFrom ggplot2 ggplot aes geom_point scale_size_continuous
#'  theme_bw theme element_blank guide_colorbar guide_legend
#'  scale_fill_gradient2 scale_fill_gradientn
#' @importFrom magrittr %>%
#' @return A ggplot2
#' @keywords internal
#'
.baseDotPlot <- function(plotData,
                         group = NULL,
                         scale = NULL,
                         AverageThreshold = NULL,
                         NumDetectedThreshold = NULL,
                         dotColors = NULL,
                         fontSize = 11,
                         fontFamily = "",
                         flipPlot = FALSE){

    stopifnot(c("NumDetected", "Feature", "Group", "Average") %in% names(plotData))
    if(is.null(group)){
        group <- "Group"
    }

    if(is.null(dotColors)){
        if(isTRUE(scale)){
            dotColors <- c(scales::muted("blue"), "white", scales::muted("red"))
        }else{
            dotColors <- c("#BFBFBF", "#FB8861FF", "#B63679FF", "#51127CFF", "#000004FF")
        }
    }

    (plotData %>%
            dplyr::mutate(alpha = dplyr::case_when(Average > !!AverageThreshold &
                                                       NumDetected > !!NumDetectedThreshold ~ 1,
                                                   .default = 0.1)) %>%
            {if(flipPlot == FALSE){
                ggplot2::ggplot(., ggplot2::aes(x = !!rlang::sym(group),
                                                y = Feature))
            }else if(flipPlot == TRUE){
                ggplot2::ggplot(., ggplot2::aes(x = Feature,
                                                y = !!rlang::sym(group)))
            }} +
            ggplot2::aes(size = NumDetected,
                         fill = Average,
                         alpha = I(alpha)) +
            ggplot2::geom_point(shape = 21,
                                color = "black") +
            ggplot2::scale_size_continuous(labels = scales::label_percent()) +
            ggplot2::theme_bw(base_size = fontSize,
                              base_family = fontFamily) +
            ggplot2::theme(axis.title = ggplot2::element_blank(),
                           axis.line = ggplot2::element_blank(),
                           axis.ticks = ggplot2::element_blank(),
                           axis.text.x = ggplot2::element_text(angle = 90,
                                                               vjust = 0.5,
                                                               hjust = 1)) +
            ggplot2::guides(fill = ggplot2::guide_colorbar(title = ifelse(scale == FALSE,
                                                                          "Log Counts",
                                                                          "Scaled Expression"),
                                                           frame.colour = "black",
                                                           ticks.colour = "black",
                                                           ticks.linewidth = 0.5,
                                                           order = 1),
                            size = ggplot2::guide_legend(title = "Percent of Cells",
                                                         order = 2)) +
            ggplot2::ylab(NULL)) %>%
        {if(scale == TRUE){
            . + ggplot2::scale_fill_gradient2(low = dotColors[1],
                                              mid = dotColors[2],
                                              high = dotColors[3])
        }else if(scale == FALSE){
            . + ggplot2::scale_fill_gradientn(colors = dotColors)
        }}
}

#' @title Create column annotations
#' @inheritParams scDotPlot
#' @importFrom ggplot2 ggplot aes geom_tile theme_void guides guide_none
#' @importFrom ggsci scale_fill_d3 scale_fill_cosmic
#' @importFrom purrr pluck
#' @importFrom grDevices colorRampPalette
#' @importFrom magrittr %>%
#' @return A ggplot2
#' @keywords internal
#'
.createAnno <- function(annoLabel,
                        annoType = c("column", "row"),
                        dotPlot = dotPlot,
                        annoColors = NULL,
                        groupLegends = TRUE,
                        featureLegends = TRUE,
                        fontSize = 11,
                        fontFamily = "",
                        flipPlot = FALSE){

    annoType <- match.arg(annoType)

    plotData <- dotPlot$data

    p1 <- plotData %>%
        {if(annoType == "column" & flipPlot == FALSE){
            ggplot2::ggplot(., ggplot2::aes(x = Group,
                                            y = 1,
                                            fill = !!rlang::sym(annoLabel)))
        }else if(annoType == "column" & flipPlot == TRUE){
            ggplot2::ggplot(., ggplot2::aes(x = 1,
                                            y = Group,
                                            fill = !!rlang::sym(annoLabel)))
        }else if(annoType == "row" & flipPlot == FALSE){
            ggplot2::ggplot(., ggplot2::aes(x = 1,
                                            y = Feature,
                                            fill = !!rlang::sym(annoLabel)))
        }else if(annoType == "row" & flipPlot == TRUE){
            ggplot2::ggplot(., ggplot2::aes(x = Feature,
                                            y = 1,
                                            fill = !!rlang::sym(annoLabel)))
        }} +
        ggplot2::geom_tile(color = "black",
                           linewidth = 0.25) +
        ggplot2::theme_void(base_size = fontSize,
                            base_family = fontFamily)

    labelLevels <- plotData %>%
        purrr::pluck(annoLabel) %>%
        unique() %>%
        length()

    if(annoLabel %in% names(annoColors)){
        p1 <- p1 + ggplot2::scale_fill_manual(values = annoColors[[annoLabel]])
    }else if(annoType == "column"){
        if(labelLevels > 3 & labelLevels < 20){
            p1 <- p1 + ggsci::scale_fill_d3("category20")
        }else if(labelLevels <= 3){
            p1 <- p1 + ggsci::scale_fill_cosmic("signature_substitutions")
        }else if(labelLevels > 20){
            pal <- grDevices::colorRampPalette(ggsci::pal_d3("category20b")(20))(labelLevels)
            p1 <- p1 + ggplot2::scale_fill_manual(values = pal)
        }
    }else if(annoType == "row"){
        p1 <- p1 + ggplot2::scale_fill_brewer(palette = "Dark2")
    }

    if((annoType == "column" & groupLegends == FALSE) |
       (annoType == "row" & featureLegends == FALSE)){
        p1 <- p1 + ggplot2::guides(fill = ggplot2::guide_none())
    }

    p1
}

#' @keywords internal
"_PACKAGE"

utils::globalVariables(c(".", "Average", "Feature", "Group", "NumDetected",
                         "avg.exp.scaled", "data", "features.plot",
                         "id", "pct.exp", ":="))

## usethis namespace: start
#' @importFrom magrittr %>% %$%
## usethis namespace: end
NULL

---
title: "scDotPlot"
author: 
  - name: "Ben Laufer"
output: 
  BiocStyle::html_document:
    toc_float: TRUE
date: "`r doc_date()`"
package: "`r pkg_ver('scDotPlot')`"
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{scDotPlot}
  %\VignetteEncoding{UTF-8}  
---

```{r Setup, include = FALSE}
knitr::opts_chunk$set(collapse = TRUE,
                      message = FALSE,
                      warning = FALSE,
                      crop = NULL)
```

# Introduction

Dot plots of single-cell RNA-seq data allow for an examination of the relationships between cell groupings (e.g. clusters) and marker gene expression. The scDotPlot package offers a unified approach to perform a hierarchical clustering analysis and add annotations to the columns and/or rows of a scRNA-seq dot plot. It works with SingleCellExperiment and Seurat objects as well as data frames. The `scDotPlot()` function uses data from `scater::plotDots()` or `Seurat::DotPlot()` along with the `aplot` package to add dendrograms from `ggtree` and optional annotations.

# Installation

```{r Install, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("scDotPlot")
```

To install the development version directly from GitHub:

```{r Install GitHub, eval = FALSE}
if (!requireNamespace("remotes", quietly = TRUE)) {
    install.packages("remotes")
}

remotes::install_github("ben-laufer/scDotPlot")
```

# SingleCellExperiment

## Prepare object

First, we normalize the object and then, for the purpose of this example, subset to remove cells without cell-type labels.

```{r Prepare SingleCellExperiment}
library(scRNAseq)
library(scuttle)

sce <- ZeiselBrainData()

sce <- sce |> 
    logNormCounts() |>  
    subset(x = _, , level2class != "(none)")
```

## Get features

The features argument accepts a character vector with the gene IDs. For this example, we quickly obtain the top markers of for each cell type and then add them to the rowData of the object.

```{r Get features SingleCellExperiment}
library(scran)
library(purrr)
library(dplyr)
library(AnnotationDbi)

features <- sce |>
    scoreMarkers(sce$level1class) |>
    map(~ .x |>
            as.data.frame() |>
            arrange(desc(mean.AUC))|>
            dplyr::slice(1:6) |>
            rownames()) |> 
    unlist2()

rowData(sce)$Marker <- features[match(rownames(sce), features)] |>
    names()
```

## Plot logcounts

Finally, we create the plot. The `group` arguments utilize the colData, while the `features` arguments use the rowData. The `paletteList` argument can be used to manually specify the colors for the annotations specified through `groupAnno` and `featureAnno`. The clustering of the columns shows that cell the cell sub-types cluster by cell-type, while the clustering of the rows shows that most of the markers clusters by their cell type.

```{r scePlot1, fig.cap = "scDotPlot of SingleCellExperiment logcounts", fig.width=12, fig.height=12, dpi=50}
library(scDotPlot)
library(ggsci)

sce |>
    scDotPlot(features = features,
              group = "level2class",
              groupAnno = "level1class",
              featureAnno = "Marker",
              groupLegends = FALSE,
              annoColors = list("level1class" = pal_d3()(7),
                                "Marker" = pal_d3()(7)),
              annoWidth = 0.02)
```

## Plot Z-scores

Plotting by Z-score through `scale = TRUE` improves the clustering result for the rows.

```{r scePlot2, fig.cap = "scDotPlot of SingleCellExperiment Z-scores", fig.width=12, fig.height=12, dpi=50}
sce |>
    scDotPlot(scale = TRUE,
              features = features,
              group = "level2class",
              groupAnno = "level1class",
              featureAnno = "Marker",
              groupLegends = FALSE,
              annoColors = list("level1class" = pal_d3()(7),
                                "Marker" = pal_d3()(7)),
              annoWidth = 0.02)
```

# Seurat

## Get features

After loading the example Seurat object, we find the top markers for each cluster and add them to the assay of interest.

```{r Get features Seurat}
library(Seurat)
library(SeuratObject)
library(tibble)

data("pbmc_small")

features <- pbmc_small |>
    FindAllMarkers(only.pos = TRUE, verbose = FALSE) |>
    group_by(cluster) |>
    dplyr::slice(1:6) |>
    dplyr::select(cluster, gene)

pbmc_small[[DefaultAssay(pbmc_small)]][[]] <- pbmc_small[[DefaultAssay(pbmc_small)]][[]] |>
    rownames_to_column("gene") |> 
    left_join(features, by = "gene") |> 
    column_to_rownames("gene")

features <- features |> 
    deframe()
```

## Plot logcounts

Plotting a Seurat object is similar to plotting a SingleCellExperiment object. 

```{r SeuratPlot1, fig.cap = "scDotPlot of Seurat logcounts", fig.width=4, fig.height=5, out.width="75%", out.height="75%", dpi=50}
pbmc_small |>
    scDotPlot(features = features,
              group = "RNA_snn_res.1",
              groupAnno = "RNA_snn_res.1",
              featureAnno = "cluster",
              annoColors = list("RNA_snn_res.1" = pal_d3()(7),
                                "cluster" = pal_d3()(7)),
              groupLegends = FALSE,
              annoWidth = 0.075)
```

## Plot Z-scores

Again, we see that plotting by Z-score improves the clustering result for the rows.

```{r SeuratPlot2, fig.cap = "scDotPlot of Seurat Z-scores", fig.width=4, fig.height=5, out.width="75%", out.height="75%", dpi=50}
pbmc_small |>
    scDotPlot(scale = TRUE,
              features = features,
              group = "RNA_snn_res.1",
              groupAnno = "RNA_snn_res.1",
              featureAnno = "cluster",
              annoColors = list("RNA_snn_res.1" = pal_d3()(7),
                                "cluster" = pal_d3()(7)),
              groupLegends = FALSE,
              annoWidth = 0.075)
```

# Package support

The [Bioconductor support site](https://support.bioconductor.org/) is the preferred method to ask for help. Before posting, it's recommended to check [previous posts](https://support.bioconductor.org/tag/scDotPlot/) for the answer and look over the [posting guide](http://www.bioconductor.org/help/support/posting-guide/). For the post, it's important to use the `scDotPlot` tag and provide both a minimal reproducible example and session information.

# Acknowledgement 

This package was inspired by the [single-cell example from aplot](https://yulab-smu.top/pkgdocs/aplot.html#a-single-cell-example).

# Session info

```{r Session info, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scDotPlot-package.R
\docType{package}
\name{scDotPlot-package}
\alias{scDotPlot-package}
\title{scDotPlot: Cluster a Single-cell RNA-seq Dot Plot}
\description{
Dot plots of single-cell RNA-seq data allow for an examination of the relationships between cell groupings (e.g. clusters) and marker gene expression. The scDotPlot package offers a unified approach to perform a hierarchical clustering analysis and add annotations to the columns and/or rows of a scRNA-seq dot plot. It works with SingleCellExperiment and Seurat objects as well as data frames.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/ben-laufer/scDotPlot}
  \item Report bugs at \url{https://github.com/ben-laufer/scDotPlot/issues}
}

}
\author{
\strong{Maintainer}: Benjamin I Laufer \email{blaufer@gmail.com}

Authors:
\itemize{
  \item Brad A Friedman
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.createAnno}
\alias{.createAnno}
\title{Create column annotations}
\usage{
.createAnno(
  annoLabel,
  annoType = c("column", "row"),
  dotPlot = dotPlot,
  annoColors = NULL,
  groupLegends = TRUE,
  featureLegends = TRUE,
  fontSize = 11,
  fontFamily = "",
  flipPlot = FALSE
)
}
\arguments{
\item{annoColors}{A list with a name for each annotation that contains
a named vector of colors, where the name is the pairing of values to colors}

\item{groupLegends}{Logical indicating whether to show legends for group
annotations}

\item{featureLegends}{Logical indicating whether to show legends for feature
annotations}

\item{fontSize}{Numeric specifying the base font size in pts}

\item{fontFamily}{Character specifying the base font family}

\item{flipPlot}{Logical indicating whether to flip the x and y coordinates}
}
\value{
A ggplot2
}
\description{
Create column annotations
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scDotPlot.R
\name{scDotPlot}
\alias{scDotPlot}
\alias{scDotPlot.SingleCellExperiment}
\alias{scDotPlot.Seurat}
\alias{scDotPlot.default}
\title{scDotPlot}
\usage{
\method{scDotPlot}{SingleCellExperiment}(
  object,
  features = features,
  group = NULL,
  block = NULL,
  swap_rownames = NULL,
  scale = FALSE,
  cluster = TRUE,
  clusterRows = cluster,
  clusterColumns = cluster,
  AverageThreshold = ifelse(scale == FALSE, 0, -Inf),
  NumDetectedThreshold = 0.01,
  groupAnno = FALSE,
  featureAnno = FALSE,
  treeWidth = 0.1,
  treeHeight = 0.1,
  annoWidth = 0.05,
  annoHeight = 0.02,
  annoColors = NULL,
  dotColors = NULL,
  groupLegends = TRUE,
  featureLegends = TRUE,
  fontSize = 11,
  fontFamily = "",
  flipPlot = FALSE,
  ...
)

\method{scDotPlot}{Seurat}(
  object,
  features = features,
  group = NULL,
  block = NULL,
  swap_rownames = NULL,
  scale = FALSE,
  cluster = TRUE,
  clusterRows = cluster,
  clusterColumns = cluster,
  AverageThreshold = ifelse(scale == FALSE, 0, -Inf),
  NumDetectedThreshold = 0.01,
  groupAnno = FALSE,
  featureAnno = FALSE,
  treeWidth = 0.1,
  treeHeight = 0.1,
  annoWidth = 0.05,
  annoHeight = 0.02,
  annoColors = NULL,
  dotColors = NULL,
  groupLegends = TRUE,
  featureLegends = TRUE,
  fontSize = 11,
  fontFamily = "",
  flipPlot = FALSE,
  ...
)

\method{scDotPlot}{default}(
  object,
  features = NULL,
  group = NULL,
  block = NULL,
  swap_rownames = NULL,
  scale = FALSE,
  cluster = TRUE,
  clusterRows = cluster,
  clusterColumns = cluster,
  AverageThreshold = ifelse(scale == FALSE, 0, -Inf),
  NumDetectedThreshold = 0.01,
  groupAnno = FALSE,
  featureAnno = FALSE,
  treeWidth = 0.1,
  treeHeight = 0.1,
  annoWidth = 0.05,
  annoHeight = 0.02,
  annoColors = NULL,
  dotColors = NULL,
  groupLegends = TRUE,
  featureLegends = TRUE,
  fontSize = 11,
  fontFamily = "",
  flipPlot = FALSE,
  ...
)

scDotPlot(object, ...)
}
\arguments{
\item{object}{An object with normalized data
\itemize{
\item \link[SingleCellExperiment:SingleCellExperiment-class]{SingleCellExperiment}
\item \link[SeuratObject:Seurat-class]{Seurat}
\item A data.frame with the following columns: "NumDetected", "Feature", "Group", "Average"
}}

\item{features}{Character vector with genes of interest}

\item{group}{Column name from colData/metadata of the object to group cells by}

\item{block}{Column name from colData of a SingleCellExperiment object
to use as a blocking factor (e.g. batch or sample)}

\item{swap_rownames}{Column name from rowData of a SingleCellExperiment
object to match to features}

\item{scale}{Logical indicating whether the data should be scaled and centered}

\item{cluster}{Logical specifying whether to perform hierarchical clustering
analysis on both the rows and columns}

\item{clusterRows}{Logical specifying whether to perform hierarchical clustering
analysis on the rows}

\item{clusterColumns}{Logical specifying whether to perform hierarchical clustering
analysis on the columns}

\item{AverageThreshold}{Numeric specifying threshold for average expression,
where values below AverageThreshold and NumDetectedThreshold are transparent}

\item{NumDetectedThreshold}{Numeric specifying threshold for fraction of cells,
where values below AverageThreshold and NumDetectedThreshold are transparent}

\item{groupAnno}{Cell annotations that are stored as names of columns
in colData of sce with annotations}

\item{featureAnno}{Feature annotations that are stored as names of rows
in rowData of sce with annotations}

\item{treeWidth}{Numeric specifying width of the row tree relative to
the dotPlot}

\item{treeHeight}{Numeric specifying height of the column tree relative to
the dotPlot}

\item{annoWidth}{Numeric specifying the width of the row annotation relative
to the dotPlot}

\item{annoHeight}{Numeric specifying height of the column annotation relative
to the dotPlot}

\item{annoColors}{A list with a name for each annotation that contains
a named vector of colors, where the name is the pairing of values to colors}

\item{dotColors}{A character vector specifying the colors to be used
in the gradient for the dots. If scale is set to TRUE, the first 3 colors
will be used for the negative, zero, and positive values, respectively.}

\item{groupLegends}{Logical indicating whether to show legends for group
annotations}

\item{featureLegends}{Logical indicating whether to show legends for feature
annotations}

\item{fontSize}{Numeric specifying the base font size in pts}

\item{fontFamily}{Character specifying the base font family}

\item{flipPlot}{Logical indicating whether to flip the x and y coordinates}

\item{...}{Additional unused arguments}
}
\value{
\itemize{
\item When \code{cluster = TRUE}, a \code{aplot} object
\item When \code{cluster = FALSE}, a \code{ggplot2} object
}
}
\description{
Create dot plot of gene expression profiles that can be
annotated with hierarchical clustering from \link[ggtree]{ggtree} using
\link[aplot:plot-insertion]{aplot}
}
\details{
The data for the dot plot is generated from different sources
depending on the object:
\itemize{
\item \code{SingleCellExperiment:} \link[scater]{plotDots}
\item \code{Seurat:} \link[Seurat]{DotPlot}
}
}
\examples{
data("pbmc_small", package = "SeuratObject")
pbmc_small |>
    scDotPlot(features = Seurat::VariableFeatures(pbmc_small),
              group = "RNA_snn_res.1")
}
\references{
\url{https://yulab-smu.top/pkgdocs/aplot.html#a-single-cell-example}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.baseDotPlot}
\alias{.baseDotPlot}
\title{Dot Plot Base}
\usage{
.baseDotPlot(
  plotData,
  group = NULL,
  scale = NULL,
  AverageThreshold = NULL,
  NumDetectedThreshold = NULL,
  dotColors = NULL,
  fontSize = 11,
  fontFamily = "",
  flipPlot = FALSE
)
}
\arguments{
\item{group}{Column name from colData/metadata of the object to group cells by}

\item{scale}{Logical indicating whether the data should be scaled and centered}

\item{AverageThreshold}{Numeric specifying threshold for average expression,
where values below AverageThreshold and NumDetectedThreshold are transparent}

\item{NumDetectedThreshold}{Numeric specifying threshold for fraction of cells,
where values below AverageThreshold and NumDetectedThreshold are transparent}

\item{dotColors}{A character vector specifying the colors to be used
in the gradient for the dots. If scale is set to TRUE, the first 3 colors
will be used for the negative, zero, and positive values, respectively.}

\item{fontSize}{Numeric specifying the base font size in pts}

\item{fontFamily}{Character specifying the base font family}

\item{flipPlot}{Logical indicating whether to flip the x and y coordinates}
}
\value{
A ggplot2
}
\description{
Dot Plot Base
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.annotateDotPlot}
\alias{.annotateDotPlot}
\title{Cluster Dot Plot}
\usage{
.annotateDotPlot(
  dotPlot,
  clusterRows = TRUE,
  clusterColumns = TRUE,
  groupAnno = FALSE,
  featureAnno = FALSE,
  treeWidth = 0.1,
  treeHeight = 0.1,
  annoWidth = 0.05,
  annoHeight = 0.02,
  annoColors = NULL,
  groupLegends = TRUE,
  featureLegends = TRUE,
  fontSize = 11,
  fontFamily = "",
  flipPlot = FALSE
)
}
\arguments{
\item{clusterRows}{Logical specifying whether to perform hierarchical clustering
analysis on the rows}

\item{clusterColumns}{Logical specifying whether to perform hierarchical clustering
analysis on the columns}

\item{groupAnno}{Cell annotations that are stored as names of columns
in colData of sce with annotations}

\item{featureAnno}{Feature annotations that are stored as names of rows
in rowData of sce with annotations}

\item{treeWidth}{Numeric specifying width of the row tree relative to
the dotPlot}

\item{treeHeight}{Numeric specifying height of the column tree relative to
the dotPlot}

\item{annoWidth}{Numeric specifying the width of the row annotation relative
to the dotPlot}

\item{annoHeight}{Numeric specifying height of the column annotation relative
to the dotPlot}

\item{annoColors}{A list with a name for each annotation that contains
a named vector of colors, where the name is the pairing of values to colors}

\item{groupLegends}{Logical indicating whether to show legends for group
annotations}

\item{featureLegends}{Logical indicating whether to show legends for feature
annotations}

\item{fontSize}{Numeric specifying the base font size in pts}

\item{fontFamily}{Character specifying the base font family}

\item{flipPlot}{Logical indicating whether to flip the x and y coordinates}
}
\value{
A aplot
}
\description{
Cluster Dot Plot
}
\keyword{internal}
